//
//  CRShareTestAppDelegate.m
//  CRShare
//
//  Created by taras on 18.08.11.
//  Copyright 2011 Company. All rights reserved.
//

#import "CRShareTestAppDelegate.h"

@implementation CRShareTestAppDelegate

@synthesize window;
@synthesize progressIndicator;
@synthesize photoView1;
@synthesize viewsCollection;
@synthesize sizesChoice;
@synthesize nameOfService;
@synthesize remoteHost;

-(void)photoIsReadyObserver: (NSNotification*)notification {
	NSData* binaryData = nil;
    binaryData = [remoteHost.hostInstance getBinaryData];
	
    [ photoView1 setImage:[[NSImage alloc] initWithData:binaryData ]];	

    [remoteHost.hostInstance getNextPhoto];

	[ progressIndicator setDoubleValue:100.0];
	[ progressIndicator setNeedsDisplay:YES];
	[ progressIndicator stopAnimation:self];
}

-(void)getPhotosFromAlbumsObserver: (NSNotification*)notification {
    [ photoView1 setImage:[[NSImage alloc] initWithData:[remoteHost.hostInstance getBinaryData] ]];
}

-(void)photoPercentIsCompletedObserver: (NSNotification*)notification {
	[ progressIndicator setNeedsDisplay:YES];
	[ progressIndicator setDoubleValue:[ remoteHost.hostInstance getPercentLoadedData ]];
	if([ remoteHost.hostInstance isDataTransferCompleted])
	    [progressIndicator stopAnimation:self];
}

//Flickr-specific method to call label that sticked to the thumbnail sizes
- (void)getLabelsForSizesObserver:(NSNotification *)aNotification{
	[ sizesChoice removeAllItems ];
	NSMutableDictionary* labels = nil;
	labels = [ remoteHost.hostInstance getLabels ];
	NSArray* keys = [ labels allKeys ];
	for(int count = 0 ; count < [keys count] ; count++){
	    [ sizesChoice addItemWithObjectValue:[keys objectAtIndex:count]];
	}
	
}

- (IBAction)buttonClickDownloadPhoto:(id)sender {
	[ remoteHost.hostInstance downloadPhotos ];
}


- (IBAction)buttonClickRequestAuth:(id)sender { 
	[ remoteHost.hostInstance authenticate ];
} 

- (IBAction)buttonClickRequestMethod:(id)sender { 
	NSString* photoPath = [[NSString alloc]initWithFormat:@""];
    
	NSOpenPanel* openDlg = [NSOpenPanel openPanel];
	
	[openDlg setCanChooseFiles:YES];
	[openDlg setCanChooseDirectories:YES];
	
	if ( [openDlg runModalForDirectory:nil file:nil] == NSOKButton )
	{
		NSArray* files = [openDlg filenames];
		for( int i = 0; i < [files count]; i++ )
		{
			photoPath = [files objectAtIndex:i];
		}
	}
	
	//photoPath = @"/Users/taras/Desktop/29072011_PHOTO_IPHONE/100APPLE/IMG_0279.JPG";
	CRShareResource* shareImage = [CRShareResource createShareResourceWithPath:photoPath];
	
	//класс-хелпер для выбора хоста, показывающий sheet в текущем окне
	remoteHost = [CRShareHostHelper chooseHostForResource:shareImage rootWindow:[self window]]; 
	NSDictionary* params = [CRShareHostHelper requestPublishingParametersForHost:remoteHost resource:shareImage rootWindow:[self window]];
	[remoteHost publishResource:shareImage params:params credentials:nil];	
	[progressIndicator setDoubleValue:0.0];
    [progressIndicator startAnimation:sender];
} 


- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	//remoteHost = [CRShareHost alloc];
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(photoIsReadyObserver:) name: @"photoIsReady" object: nil];
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(photoPercentIsCompletedObserver:) name: @"photoPercentIsCompleted" object: nil];
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(getLabelsForSizesObserver:) name: @"getLabelsForSizes" object: nil];
    [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(getPhotosFromAlbumsObserver:) name: @"getPhotosFromAlbums" object: nil];
	
	[ progressIndicator setMinValue:0.0];
	[ progressIndicator setMaxValue:100.0];
	[ progressIndicator setDoubleValue:0.0];
    [ progressIndicator setIndeterminate: NO];
}


@end
