//
//  CRShareTestAppDelegate.m
//  CRShare
//
//  Created by taras on 18.08.11.
//  Copyright 2011 Company. All rights reserved.
//

#import "CRShareTestUIAppDelegate.h"

@implementation CRShareTestUIAppDelegate

@synthesize window;
@synthesize progressIndicator;
@synthesize photoView1;
@synthesize viewsCollection;
@synthesize sizesChoice;
@synthesize nameOfService;
@synthesize remoteHost;

-(void)photoIsReadyObserver: (NSNotification*)notification {
	NSDictionary* userDict = [notification userInfo];
	NSData* binaryData = [ userDict objectForKey:@"data"];
	//CRShareHost* theHost = [notification object];
    //NSData* binaryData = [remoteHost.hostInstance getBinaryData];
	
    [ photoView1 setImage:[[NSImage alloc] initWithData:binaryData ]];	

    [[self getHostInstance] getNextPhoto];

	[ progressIndicator setDoubleValue:100.0];
	[ progressIndicator setNeedsDisplay:YES];
	[ progressIndicator stopAnimation:self];
}

-(void)getPhotosFromAlbumsObserver: (NSNotification*)notification {
	NSData* binaryData = [[self getHostInstance] getBinaryData];
    [ photoView1 setImage:[[NSImage alloc] initWithData: binaryData ]];
}

-(void)photoPercentIsCompletedObserver: (NSNotification*)notification {
	[ progressIndicator setNeedsDisplay:YES];
	[ progressIndicator setDoubleValue:[ [self getHostInstance] getPercentLoadedData ]];
	if([ [self getHostInstance] isDataTransferCompleted])
	    [progressIndicator stopAnimation:self];
}

//Flickr-specific method to call label that sticked to the thumbnail sizes
- (void)getLabelsForSizesObserver:(NSNotification *)aNotification{
	[ sizesChoice removeAllItems ];
	NSMutableDictionary* labels = nil;
	labels = [ [self getHostInstance] getLabels ];
	NSArray* keys = [ labels allKeys ];
	for(int count = 0 ; count < [keys count] ; count++){
	    [ sizesChoice addItemWithObjectValue:[keys objectAtIndex:count]];
	}
	
}

- (IBAction)buttonClickDownloadPhoto:(id)sender {
	if([self getHostInstance]){
	    [ [self getHostInstance] downloadPhotos ];
	}
}


- (IBAction)buttonClickRequestAuth:(id)sender { 
	[ [self getHostInstance] authenticate ];
} 

- (IBAction)buttonClickRequestMethod:(id)sender { 
	NSString* photoPath = [[NSString alloc]initWithFormat:@""];
    NSString* hostName = [[NSString alloc]initWithFormat:@"Facebook"];
	
	NSOpenPanel* openDlg = [NSOpenPanel openPanel];
	
	[openDlg setCanChooseFiles:YES];
	[openDlg setCanChooseDirectories:YES];
	
	if ( [openDlg runModalForDirectory:nil file:nil] == NSOKButton )
	{
		NSArray* files = [openDlg filenames];
		for( int i = 0; i < [files count]; i++ )
		{
			photoPath = [files objectAtIndex:i];
		}
	}
	
	//photoPath = @"/Users/taras/Desktop/29072011_PHOTO_IPHONE/100APPLE/IMG_0279.JPG";
	
	NSData* photoData = [[NSData alloc] initWithContentsOfFile:photoPath];
	CRShareResource* shareImage = [CRShareResource createShareResourceWithData:photoData name:photoPath];
	/* 
	//CRShareResource* shareImage = [CRShareResource createShareResourceWithPath:photoPath];
	
	//класс-хелпер для выбора хоста, показывающий sheet в текущем окне
	remoteHost = [[[CRShareHostHelper sharedHelper] chooseHostForResource:shareImage rootWindow:[self window]]retain]; 
	NSDictionary* params = [[CRShareHostHelper sharedHelper] requestPublishingParametersForHost:remoteHost resource:shareImage rootWindow:[self window]];
	[remoteHost publishResource:shareImage parameters:params credentials:nil];
	*/
	//CRShareResource* shareImage = [CRShareResource createShareResourceWithData:[bitmap representationUsingType:NSJPEGFileType properties:nil] name:photoPath];
	//remoteHost = [[self getHostHelper] chooseHostForResource:shareImage rootWindow:[self window]];
	NSDictionary* params = [[self getHostHelper] requestPublishingParametersForHost:[self getHost:hostName] 
												      resource:shareImage rootWindow:[self window]];
	if (nil != params) // nil here means an error or user-canceled process
		[[self getHostHelper] shareResource:shareImage withHost:[self getHost:hostName] 
								 parameters:params rootWindow:[self window]];
	
	
	//NSLog(@"remoteHost=%@", [self getHost]);
	[progressIndicator setDoubleValue:0.0];
    [progressIndicator startAnimation:sender];
} 

- (IBAction)buttonClickGetHost:(id)sender{
	//[self getHost];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(photoIsReadyObserver:) name: @"photoIsReady" object: nil];
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(photoPercentIsCompletedObserver:) name: @"photoPercentIsCompleted" object: nil];
	[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(getLabelsForSizesObserver:) name: @"getLabelsForSizes" object: nil];
    [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(getPhotosFromAlbumsObserver:) name: @"getPhotosFromAlbums" object: nil];
	//[[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(getPhotosFromAlbumsObserver:) name:CRAlbumsNotificationFacebook object:nil];
	
	
	[ progressIndicator setMinValue:0.0];
	[ progressIndicator setMaxValue:100.0];
	[ progressIndicator setDoubleValue:0.0];
    [ progressIndicator setIndeterminate: NO];
}

-(CRShareHostHelper*)getHostHelper{
    if(nil == hostHelper){
        hostHelper = [CRShareHostHelper sharedHelper];
	}
	return hostHelper;
}

-(CRShareHost*)getHost:(NSString *)hostName{
	if (nil == remoteHost) {
        //CRShareResource* shareImage = [CRShareResource createShareResourceWithData:[bitmap representationUsingType:NSJPEGFileType properties:nil] name:photoPath];
		remoteHost = [[self getHostHelper] getHost: hostName rootWindow: [self window] ];
		NSLog(@"remoteHost=%@", remoteHost);		
	}
	return remoteHost;
}

-(id)getHostInstance{
	if (nil == remoteHost) {
        //CRShareResource* shareImage = [CRShareResource createShareResourceWithData:[bitmap representationUsingType:NSJPEGFileType properties:nil] name:photoPath];
		remoteHost = [[self getHostHelper] getHost:@"Facebook" rootWindow:[self window] ];
		//NSLog(@"remoteHost=%@", remoteHost);		
	}
	return remoteHost.hostInstance;
}

@end
